#include "Product.h"


//!!! Где форматированный вывод в текстовый файл в виде таблицы с шапкой?


void Product::NewProduct() {
	std::cout << "\tEnter the warehouse number:";
	std::cin >> number_warehouse;
	std::cout << "\tEnter the product code:";
	std::cin >> code;
	std::cout << "\tEnter the product name:";
	std::cin >> name;
	std::cout << "\tEnter the date of receipt to the warehouse:" << std::endl << "\t\tday:";
	std::cin >> date_day;
	std::cout << "\t\tmonth:";
	std::cin >> date_month;
	std::cout << "\t\tyear:";
	std::cin >> date_year;
	std::cout << "\tEnter the retention period in days:";
	std::cin >> shelf_life;
	std::cout << "\tEnter the number of units of the product:";
	std::cin >> quantity;
	std::cout << "\tEnter the unit price:";
	std::cin >> price;
}


int Product::date_in_days() {
	return atoi(date_year) * 365 + atoi(date_month) * 30 + atoi(date_day);
}

int Product::Output_number_warehouse() {
	return atoi(number_warehouse);
}
int Product::Output_code() {
	return atoi(code);
}
std::vector<int> Product::Output_date() {
	std::vector<int> date;
	date.push_back(atoi(date_day));
	date.push_back(atoi(date_month));
	date.push_back(atoi(date_year));
	return date;
}
int Product::Output_shelf_life() {
	return atoi(shelf_life);
}

std::string Product::Output_name() {
	return name;
}

int Product::Output_quantity() {
	return atoi(quantity);
}

int Product::Output_price() {
	return atoi(price);
}






//!!! Зачем тут нужен указатель на указатель? Чем Product& не подходит?
Product** List_Product::operator[](size_t num) {
	return &map_Product[num];
}






void List_Product::Output_from_file(std::ifstream& file) {
	Product* elem=new Product;  //!!! Что тут за new? Зачем? Где delete тогда? Почему просто Product elem; нельзя?
	
	while (file.read((char*)elem, sizeof(Product))) { //!!! Нужно использовать reinterpret_cast 
		map_Product[++size]=elem;
		elem = new Product;  //!!! Что тут за new? Зачем? Где delete тогда?
	}
}

void List_Product::Output_in_file(std::ofstream& file) {
	for_each(map_Product.begin(), map_Product.end(), [&](auto elem) { //!!! Копирвоание elem
		file.write((char*)(elem.second), sizeof(Product));  //!!! Нужно использовать reinterpret_cast
		delete elem.second;
		});
}

std::map<size_t, Product*>& List_Product::Output_map_Product() {
	return map_Product;
}

List_Product List_Product::Search_by_warehouse_number() {
	int number;
	std::cout << "Enter the warehouse number:";
	std::cin >> number;
	List_Product result;
	for (auto& i : map_Product) {
		if (i.second->Output_number_warehouse() == number) {
		    
			*result[++(result.size)] = new Product; //!!! Что тут за new? Зачем? Где delete тогда?
			
			**result[(result.size)] = *i.second;
		}
		delete i.second;
	}
	return result;
}

List_Product List_Product::Search_by_product_code() {
	int code;
	std::cout << "Enter the product code:";
	std::cin >> code;
	List_Product result;
	
	//!!! По заданию нужно использовать алгоритмы
	
	for (auto& i : map_Product) {
		if (i.second->Output_code() == code) {
			*result[++(result.size)] = new Product; //!!! Что тут за new? Зачем? Где delete тогда?
			**result[(result.size)] = *i.second;
		}
		delete i.second;
	}
	return result;
}

List_Product List_Product::Search_by_date_of_receipt() {
    //!!! По заданию нужно использовать алгоритмы
    
	int day,month,year;
	std::cout << "Enter the date:" << std::endl;
	std::cout << "\tday: ";
	std::cin >> day;
	std::cout << "\tmonth: ";
	std::cin >> month;
	std::cout << "\tyear: ";
	std::cin >> year;
	std::vector<int> date;
	List_Product result;
	for (auto& i : map_Product) {
		date = i.second->Output_date();
		if (date.at(0)==day || date.at(1)==month || date.at(2)==year) {
			*result[++(result.size)] = new Product;
			**result[(result.size)] = *i.second;
		}
		delete i.second;
	}
	return result;
}

List_Product List_Product::Search_by_shelf_life() {
    //!!! По заданию нужно использовать алгоритмы
    
	bool overdue_or_no;
	int day,month,year,date_in_days;
	std::cout << "Find..." << std::endl
		<< "\t1 - expired products" << std::endl
		<< "\t0 - non-expired products"<<std::endl;
	std::cin >> overdue_or_no;
	std::cout << "Enter today's date:" << std::endl;
	std::cout << "\tday: ";
	std::cin >> day;
	std::cout << "\tmonth: ";
	std::cin >> month;
	std::cout << "\tyear: ";
	std::cin >> year;
	date_in_days= year * 365 + month * 30 + day;
	List_Product result;
	if (overdue_or_no == 1) {
		for (auto& i : map_Product) {
			if(i.second->date_in_days()+i.second->Output_shelf_life()<=date_in_days) {
				*result[++(result.size)] = new Product;  //!!! Что тут за new? Зачем? Где delete тогда?
				**result[(result.size)] = *i.second;
			}
			delete i.second;
		}
	}
	else {
		for (auto& i : map_Product) {
			if (i.second->date_in_days() + i.second->Output_shelf_life() > date_in_days) {
				*result[++(result.size)] = new Product;  //!!! Что тут за new? Зачем? Где delete тогда?
				**result[(result.size)] = *i.second;
			}
			delete i.second;
		}
	}
	return result;
}